<?php
	
	
		global $wpdb;
		
		$gnosisFieldsTable = $wpdb->prefix . 'gnosis_fields';
		$gnosisCustomTable = $wpdb->prefix . 'gnosis_custom';
		$gnosisSettingsTable = $wpdb->prefix . 'gnosis_settings';

		
		/* PROCESSING OF FORM SUBMISSIONS */

		// If user_id_submit is set, add user_id to database
		if (isset($_POST['user_id_submit'])) {
			
			$userId = stripslashes(filter_var($_POST['user_id'], FILTER_SANITIZE_STRING));
			$submitText = stripslashes(filter_var($_POST['submit_text'], FILTER_SANITIZE_STRING));
			
			
			$gnosisSettingsTable = $wpdb->prefix . 'gnosis_settings';
			
			$wpdb->query("TRUNCATE TABLE $gnosisSettingsTable");
			$wpdb->insert($gnosisSettingsTable, array('gnosis_settings_user' => $userId, 'gnosis_settings_submit_text' => $submitText), array('%s'));
			
			$success = true;
					
		}
		
		
		// If field_settings_submit is set, add field settings to database
		if (isset($_POST['field_settings_submit'])) {
			$fieldSettings = $_POST;
			
			foreach ($fieldSettings as $fieldSetting) {
			
				$attribute = $fieldSetting['attribute'];
				$name = stripslashes(filter_var($fieldSetting['name'], FILTER_SANITIZE_STRING));
				$display = $fieldSetting['display'];
				$require = $fieldSetting['require'];
			
				$success = $wpdb->update(
					
					$gnosisFieldsTable, 
					
					// Data to update
					array(
						'gnosis_fields_name' => $name, 			// String
						'gnosis_fields_display' => $display, 	// Boolean integer
						'gnosis_fields_require' => $require		// Boolean integer
					), 
					
					// Where
					array(
						'gnosis_fields_attribute' => $attribute	// gnosis_fields_attribute == $attribute
					), 
					
					// Data types
					array(
						'%s', 	// String
						'%d', 	// Boolean integer
						'%d'	// Boolean integer
					)
					
				);
							
			}
			
			if ($success !== false) {
				$success = true;
			}
			
		}
		
		
		// If custom_attributes_submit is set, add custom attributes to database
		if (isset($_POST['custom_attributes_submit'])) {
			$customAttributes = $_POST;
			
			foreach ($customAttributes as $id => $customAttribute) {
				$customId = $customAttribute['attribute_id'];
				$attribute = stripslashes(filter_var($customAttribute['attribute'], FILTER_SANITIZE_STRING));
				$name = stripslashes(filter_var($customAttribute['name'], FILTER_SANITIZE_STRING));
				$datatype = $customAttribute['datatype'];
				$display = $customAttribute['display'];
				$require = $customAttribute['require'];
				
				// If it's a new entry
				$gnosisCustomAttributes = $wpdb->get_results("SELECT * FROM $gnosisCustomTable", OBJECT_K);
				if ($id > lastId($gnosisCustomAttributes)) {
					$wpdb->insert($gnosisCustomTable, array(
						'gnosis_fields_attribute' => $attribute, 
						'gnosis_fields_name' => $name, 
						'gnosis_fields_datatype' => $datatype, 
						'gnosis_fields_display' => $display, 
						'gnosis_fields_require' => $require
				
					));
				
				} elseif ($id <= lastId($gnosisCustomAttributes)) {
					// Update records
					
					$success = $wpdb->update(
					
						$gnosisCustomTable, 
					
						// Data to update
						array(
							'gnosis_fields_attribute' => $attribute, 	// String
							'gnosis_fields_name' => $name, 				// String
							'gnosis_fields_datatype' => $datatype, 		// String
							'gnosis_fields_display' => $display, 		// Boolean integer
							'gnosis_fields_require' => $require			// Boolean integer
						), 
					
						// Where
						array(
							'gnosis_fields_id' => $customId	// gnosis_fields_attribute == $attribute
						), 
					
						// Data types
						array(
							'%s', 	// String
							'%s', 	// String
							'%s', 	// String
							'%d', 	// Boolean integer
							'%d'	// Boolean integer
						)
					
					);
					
				}
				unset($gnosisCustomAttributes);
			
			}
			
			if ($success !== false) {
				$success = true;
			}
			
		}
		
		// If custom_attributes_delete is selected
		if (isset($_POST['custom_attributes_delete'])) {
			// Delete custom attribute using ID
			foreach ($_POST['custom_attributes_delete'] as $k => $v) {
				$wpdb->delete($gnosisCustomTable, array('gnosis_fields_id' => $k));
			}
			if ($success !== false) {
				$success = true;
			}
		}
		
		
		// Getting standard attributes fields
		$gnosisSettings = $wpdb->get_results("SELECT * FROM $gnosisFieldsTable", OBJECT_K);
		
		// Getting custom attributes fields
		$gnosisCustomAttributes = $wpdb->get_results("SELECT * FROM $gnosisCustomTable", OBJECT_K);
		
		// Getting the last key for incrementing custom attributes
		function lastId($gnosisCustomAttributes) {
			end($gnosisCustomAttributes);
			$lastId = key($gnosisCustomAttributes);
			return $lastId;
		}

		// Getting user info/ID
		$gnosisUsers = $wpdb->get_results("SELECT * FROM $gnosisSettingsTable", ARRAY_N);

?>

<script>

// Accordian for sections of settings
jQuery(document).ready(function(){
	jQuery(document).ready(function(jQuery) {
		var allPanels = jQuery('#gnosis .hide').hide();

		jQuery('#gnosis .show').click(function() {
			allPanels.slideUp();
			jQuery(this).next().slideDown(600);
			return false;
		});		
	});
});

// Update URL as user inputs their user ID
jQuery(document).ready(function(){
	jQuery(function($) {
		jQuery('#user_id').live('keyup', function(e) {
			jQuery('#user_id_display').text($(this).val());
		});
	});
});

// Adding custom attributes
jQuery(document).ready(function(){
	
	var id = '<?= lastId($gnosisCustomAttributes); ?>';	// Last ID from the database to increment from
		
	jQuery("#custom_attributes_add").click(function(e){
		e.preventDefault();
		id++	// Incrementing ID
		
		// Create new table row in here
		
		// Printing out new table row
		jQuery('#custom_attributes tr:last').after('<tr> <td><input type="text" name="' + id + '[attribute]" value="" /></td> <td><input type="text" name="' + id + '[name]" value="" /></td> <td><select name="' + id + '[datatype]"><option value="string">Text & Numeric</option><option value="boolean">Boolean</option><option value="date">Date</option></select></td> <td><input type="radio" name="' + id + '[display]" value="1" /> Yes &nbsp;&nbsp;&nbsp;<input type="radio" name="' + id + '[display]" value="0" checked /> No</td> <td><input type="radio" name="' + id + '[require]" value="1" /> Yes &nbsp;&nbsp;&nbsp;<input type="radio" name="' + id + '[require]" value="0" checked /> No</td> <td><input type="submit" id="' + id + '" name="custom_attributes_delete" class="button button-secondary button-large" value="Delete" /></td></tr>');
		
	});
});


</script>

<h2>Gnosis Person Data Collection Widget Config</h2>

<div id="gnosis">

<?php if (isset($success)) { ?>

<div id="messages">

	<?php if ($success == true) { ?>
	
	<div class="success">
		Information successfully updated!
	</div>
	
	<?php } elseif ($success == false) { ?>
	
	<div class="error">
		An error occurred, please try again.
	</div>
	
	<?php } ?>
	
</div>

<?php } else { ?>
	
	<div class="info">
		Gnosis Person Data Collection Widget Configuration. Click on a menu item below to configure this widget.
	</div>
	
<?php } ?>


<a class="show"><h3>Plugin Settings</h3></a>
<div class="hide">
<p>
	<form id="gnosis_id" name="gnosis_id" action="" method="POST">
		<table>
			<tr>
				<th>Organization ID</th>
				<th>Post URL</th>
			</tr>
						
			<tr>
				<td>
					<input type="text" name="user_id" id="user_id" onClick="this.select();" <?php if (isset($gnosisUsers[0][1])) { echo 'value="' . $gnosisUsers[0][1] . '"'; } ?> />
				</td>
				<td>
					http://<div id="user_id_display"><?php if (isset($gnosisUsers[0][1])) { echo $gnosisUsers[0][1]; } else { echo 'userid'; } ?></div>.gnosishosting.net/Connect4/Handlers/RemoteDataInput.ashx
				</td>
			</tr>
		</table>
		<br />
		<table>
			<tr>
				<th>Submit button text: </th>
				<td><input type="text" name="submit_text" id="submit_text" onClick="this.select();" <?php if (isset($gnosisUsers[0][2])) { echo 'value="' . $gnosisUsers[0][2] . '"'; } ?> /></td>
			</tr>
		</table>
		
		<br />
		<input type="submit" id="user_id_submit" name="user_id_submit" class="button button-primary button-large" value="Save" />
		<br />
	</form>
</p>
</div>

<hr />

<a class="show"><h3>Standard Fields</h3></a>
<div class="hide">
<p>
	<form id="gnosis_fields" name="gnosis_fields" action="" method="POST">
		<table>
			<tr>
				<th>Attribute</th>
				<th>Display Name</th>
				<th>Display</th>
				<th>Require</th>
			</tr>
			
			<?php foreach ($gnosisSettings as $gnosisSetting) { ?>
					
					<input type="hidden" name="<?php echo $gnosisSetting->gnosis_fields_id; ?>[attribute]" value="<?php echo $gnosisSetting->gnosis_fields_attribute; ?>" />
					
					<tr>
						<td><?php echo $gnosisSetting->gnosis_fields_attribute; ?></td>
						<td><input type="text" name="<?php echo $gnosisSetting->gnosis_fields_id; ?>[name]" value="<?php echo $gnosisSetting->gnosis_fields_name; ?>" onClick="this.select();" /></td>
						<td>
							
							<?php 
								if ($gnosisSetting->gnosis_fields_attribute == 'PFirstName' or $gnosisSetting->gnosis_fields_attribute == 'PLastName' or $gnosisSetting->gnosis_fields_attribute == 'EEmailAddress') {
								
								echo 'Required' . '<input type="hidden" name="' . $gnosisSetting->gnosis_fields_id . '[display]" value="1" />'; } else { ?>
							
							<input type="radio" name="<?php echo $gnosisSetting->gnosis_fields_id; ?>[display]" value="1" <?php if ($gnosisSetting->gnosis_fields_display == 1) { echo 'checked'; } ?> /> Yes &nbsp;&nbsp;&nbsp; 
							
							<input type="radio" name="<?php echo $gnosisSetting->gnosis_fields_id; ?>[display]" value="0" <?php if ($gnosisSetting->gnosis_fields_display == 0) { echo 'checked'; } ?> /> No
						
						<?php } ?>
						
						</td>
						
						<td>
						
							<?php 
								if ($gnosisSetting->gnosis_fields_attribute == 'PFirstName' or $gnosisSetting->gnosis_fields_attribute == 'PLastName' or $gnosisSetting->gnosis_fields_attribute == 'EEmailAddress') {
								
								echo 'Required' . '<input type="hidden" name="' . $gnosisSetting->gnosis_fields_id . '[require]" value="1" />';; } else { ?>
								
							<input type="radio" name="<?php echo $gnosisSetting->gnosis_fields_id; ?>[require]" value="1" <?php if ($gnosisSetting->gnosis_fields_require == 1) { echo 'checked'; } ?> /> Yes &nbsp;&nbsp;&nbsp; 
						
							<input type="radio" name="<?php echo $gnosisSetting->gnosis_fields_id; ?>[require]" value="0" <?php if ($gnosisSetting->gnosis_fields_require == 0) { echo 'checked'; } ?> /> No
						
						<?php } ?>
						
						</td>
					</tr>
					
					<?php
				}
			?>
					
		</table>
		<br />
		<input type="submit" id="field_settings_submit" name="field_settings_submit" class="button button-primary button-large" value="Save" />
		<br />
	</form>
</p>
</div>

<hr />

<a class="show"><h3>Custom Attributes</h3></a>
<div class="hide">
<p>

	<form id="gnosis_custom_attributes" name="gnosis_custom_attributes" action="" method="POST">
			<table id="custom_attributes">
				<tr>
					<th>Attribute ID</th>
					<th>Display Name</th>
					<th>Data Type</th>
					<th>Display</th>
					<th>Require</th>
					<th>Remove Attribute</th>
				</tr>
				
				<?php foreach ($gnosisCustomAttributes as $gnosisCustomAttribute) { ?>
										
					<tr>
						
						<td><input type="text" name="<?php echo $gnosisCustomAttribute->gnosis_fields_id; ?>[attribute]" onClick="this.select();" value="<?php echo $gnosisCustomAttribute->gnosis_fields_attribute; ?>" /> </td>
						
						<td><input type="text" name="<?php echo $gnosisCustomAttribute->gnosis_fields_id; ?>[name]" onClick="this.select();" value="<?php echo $gnosisCustomAttribute->gnosis_fields_name; ?>" /> </td>
						
						<td>
							<select name="<?php echo $gnosisCustomAttribute->gnosis_fields_id; ?>[datatype]">
								<option value="string" <?php if ($gnosisCustomAttribute->gnosis_fields_datatype == 'string') { echo 'selected'; } ?>>Text & Numeric</option>
								<option value="boolean" <?php if ($gnosisCustomAttribute->gnosis_fields_datatype == 'boolean') { echo 'selected'; } ?>>Boolean</option>
								<option value="date" <?php if ($gnosisCustomAttribute->gnosis_fields_datatype == 'date') { echo 'selected'; } ?>>Date</option>
							</select>
						</td>
						
						<td>
							<input type="radio" name="<?php echo $gnosisCustomAttribute->gnosis_fields_id; ?>[display]" value="1" <?php if ($gnosisCustomAttribute->gnosis_fields_display == 1) { echo 'checked'; } ?> /> Yes &nbsp;&nbsp;&nbsp; 
						
							<input type="radio" name="<?php echo $gnosisCustomAttribute->gnosis_fields_id; ?>[display]" value="0" <?php if ($gnosisCustomAttribute->gnosis_fields_display == 0) { echo 'checked'; } ?> /> No
						</td>	
						
						<td>
							<input type="radio" name="<?php echo $gnosisCustomAttribute->gnosis_fields_id; ?>[require]" value="1" <?php if ($gnosisCustomAttribute->gnosis_fields_require == 1) { echo 'checked'; } ?> /> Yes &nbsp;&nbsp;&nbsp; 
						
							<input type="radio" name="<?php echo $gnosisCustomAttribute->gnosis_fields_id; ?>[require]" value="0" <?php if ($gnosisCustomAttribute->gnosis_fields_require == 0) { echo 'checked'; } ?> /> No
						</td>	
						
						
						<input type="hidden" name="<?php echo $gnosisCustomAttribute->gnosis_fields_id; ?>[attribute_id]" value="<?php echo $gnosisCustomAttribute->gnosis_fields_id; ?>" />
						
						
						<td><input type="submit" id="<?php echo $gnosisCustomAttribute->gnosis_fields_id; ?>" name="custom_attributes_delete[<?php echo $gnosisCustomAttribute->gnosis_fields_id; ?>]" class="button button-secondary button-large" value="Delete" /></td>
					
					</tr>
					
				<?php } ?>
				
			</table>
				
		<br />
		<input type="submit" id="custom_attributes_add" name="custom_attributes_add" class="button button-secondary button-large" value="Add New" />
		<input type="submit" id="custom_attributes_submit" name="custom_attributes_submit" class="button button-primary button-large" value="Save" />
		<br />
	</form>

</p>
</div>
	

</div>